/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupMembership type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupMembership{}

// GroupMembership struct for GroupMembership
type GroupMembership struct {
	ParentGroupId *string        `json:"parentGroupId,omitempty"`
	ChildGroupId  *string        `json:"childGroupId,omitempty"`
	Comment       NullableString `json:"comment,omitempty"`
	Builtin       *bool          `json:"builtin,omitempty"`
}

// NewGroupMembership instantiates a new GroupMembership object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupMembership() *GroupMembership {
	this := GroupMembership{}
	return &this
}

// NewGroupMembershipWithDefaults instantiates a new GroupMembership object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupMembershipWithDefaults() *GroupMembership {
	this := GroupMembership{}
	return &this
}

// GetParentGroupId returns the ParentGroupId field value if set, zero value otherwise.
func (o *GroupMembership) GetParentGroupId() string {
	if o == nil || IsNil(o.ParentGroupId) {
		var ret string
		return ret
	}
	return *o.ParentGroupId
}

// GetParentGroupIdOk returns a tuple with the ParentGroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMembership) GetParentGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.ParentGroupId) {
		return nil, false
	}
	return o.ParentGroupId, true
}

// HasParentGroupId returns a boolean if a field has been set.
func (o *GroupMembership) HasParentGroupId() bool {
	if o != nil && !IsNil(o.ParentGroupId) {
		return true
	}

	return false
}

// SetParentGroupId gets a reference to the given string and assigns it to the ParentGroupId field.
func (o *GroupMembership) SetParentGroupId(v string) {
	o.ParentGroupId = &v
}

// GetChildGroupId returns the ChildGroupId field value if set, zero value otherwise.
func (o *GroupMembership) GetChildGroupId() string {
	if o == nil || IsNil(o.ChildGroupId) {
		var ret string
		return ret
	}
	return *o.ChildGroupId
}

// GetChildGroupIdOk returns a tuple with the ChildGroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMembership) GetChildGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChildGroupId) {
		return nil, false
	}
	return o.ChildGroupId, true
}

// HasChildGroupId returns a boolean if a field has been set.
func (o *GroupMembership) HasChildGroupId() bool {
	if o != nil && !IsNil(o.ChildGroupId) {
		return true
	}

	return false
}

// SetChildGroupId gets a reference to the given string and assigns it to the ChildGroupId field.
func (o *GroupMembership) SetChildGroupId(v string) {
	o.ChildGroupId = &v
}

// GetComment returns the Comment field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMembership) GetComment() string {
	if o == nil || IsNil(o.Comment.Get()) {
		var ret string
		return ret
	}
	return *o.Comment.Get()
}

// GetCommentOk returns a tuple with the Comment field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMembership) GetCommentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Comment.Get(), o.Comment.IsSet()
}

// HasComment returns a boolean if a field has been set.
func (o *GroupMembership) HasComment() bool {
	if o != nil && o.Comment.IsSet() {
		return true
	}

	return false
}

// SetComment gets a reference to the given NullableString and assigns it to the Comment field.
func (o *GroupMembership) SetComment(v string) {
	o.Comment.Set(&v)
}

// SetCommentNil sets the value for Comment to be an explicit nil
func (o *GroupMembership) SetCommentNil() {
	o.Comment.Set(nil)
}

// UnsetComment ensures that no value is present for Comment, not even an explicit nil
func (o *GroupMembership) UnsetComment() {
	o.Comment.Unset()
}

// GetBuiltin returns the Builtin field value if set, zero value otherwise.
func (o *GroupMembership) GetBuiltin() bool {
	if o == nil || IsNil(o.Builtin) {
		var ret bool
		return ret
	}
	return *o.Builtin
}

// GetBuiltinOk returns a tuple with the Builtin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMembership) GetBuiltinOk() (*bool, bool) {
	if o == nil || IsNil(o.Builtin) {
		return nil, false
	}
	return o.Builtin, true
}

// HasBuiltin returns a boolean if a field has been set.
func (o *GroupMembership) HasBuiltin() bool {
	if o != nil && !IsNil(o.Builtin) {
		return true
	}

	return false
}

// SetBuiltin gets a reference to the given bool and assigns it to the Builtin field.
func (o *GroupMembership) SetBuiltin(v bool) {
	o.Builtin = &v
}

func (o GroupMembership) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupMembership) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ParentGroupId) {
		toSerialize["parentGroupId"] = o.ParentGroupId
	}
	if !IsNil(o.ChildGroupId) {
		toSerialize["childGroupId"] = o.ChildGroupId
	}
	if o.Comment.IsSet() {
		toSerialize["comment"] = o.Comment.Get()
	}
	if !IsNil(o.Builtin) {
		toSerialize["builtin"] = o.Builtin
	}
	return toSerialize, nil
}

type NullableGroupMembership struct {
	value *GroupMembership
	isSet bool
}

func (v NullableGroupMembership) Get() *GroupMembership {
	return v.value
}

func (v *NullableGroupMembership) Set(val *GroupMembership) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupMembership) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupMembership) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupMembership(val *GroupMembership) *NullableGroupMembership {
	return &NullableGroupMembership{value: val, isSet: true}
}

func (v NullableGroupMembership) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupMembership) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
